# Amethyst - An experimental Minecraft server written in Elixir.
# Copyright (C) 2024 KodiCraft
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

defmodule Amethyst.Minecraft.Sha1 do
  @moduledoc """
  This module implements the awkward non-standard hex digest hash that Minecraft uses
  """
  def hash(input) do
    # this sucks but so does the fact that mojang makes me do this so it fits
    <<number::integer-signed-size(20*8)>> = :crypto.hash(:sha, input)
    inspect(number, base: :hex) |> String.replace("0x", "") |> String.downcase()
  end
end
